package com.xy.config;

import com.dtp.core.support.DynamicTp;
import com.xy.utils.ThreadPoolUtils;
import org.springframework.context.annotation.Bean;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Component;

import java.util.concurrent.ThreadPoolExecutor;

@Component
public class ThreadPoolConfig {

    public static final String DEVICE_CREATE_IDS_SAVE = "deviceCreateIdsSave";

    /**
     * 设备-机器ID生成线程池
     */
    @DynamicTp
    @Bean(DEVICE_CREATE_IDS_SAVE)
    public ThreadPoolTaskExecutor deviceCreateIdsSave() {
        return ThreadPoolUtils.newPoll()
                .name(DEVICE_CREATE_IDS_SAVE)
                .coreSize(10)
                .maxSize(200)
                .keepAlive(30)
                .rejected(new ThreadPoolExecutor.CallerRunsPolicy())
                .builder();
    }

}
